/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/s390/s390.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "toplev.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"

int
const0_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return 
#line 31 "../../gcc/config/s390/predicates.md"
(op == CONST0_RTX (mode));
}

int
consttable_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
    case CONST_INT:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return 
#line 37 "../../gcc/config/s390/predicates.md"
(CONSTANT_P (op));
}

static inline int
s_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 44 "../../gcc/config/s390/predicates.md"
{
  /* Just like memory_operand, allow (subreg (mem ...))
     after reload.  */
  if (reload_completed
      && GET_CODE (op) == SUBREG
      && GET_CODE (SUBREG_REG (op)) == MEM)
    op = SUBREG_REG (op);

  if (GET_CODE (op) != MEM)
    return false;
  if (!s390_legitimate_address_without_index_p (op))
    return false;

  return true;
}

int
s_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SUBREG || GET_CODE (op) == MEM) && (general_operand (op, mode))) && (
(s_operand_1 (op, mode)));
}

int
bras_sym_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 65 "../../gcc/config/s390/predicates.md"
(!flag_pic || SYMBOL_REF_LOCAL_P (op)))) || ((GET_CODE (op) == CONST) && ((
#line 67 "../../gcc/config/s390/predicates.md"
(GET_CODE (XEXP (op, 0)) == UNSPEC)) && (
#line 68 "../../gcc/config/s390/predicates.md"
(XINT (XEXP (op, 0), 1) == UNSPEC_PLT))));
}

int
s390_plus_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS) && ((
#line 75 "../../gcc/config/s390/predicates.md"
(mode == Pmode)) && (
#line 76 "../../gcc/config/s390/predicates.md"
(!legitimate_la_operand_p (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
shift_count_or_setmem_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 82 "../../gcc/config/s390/predicates.md"
{
  HOST_WIDE_INT offset;
  rtx base;

  /* Extract base register and offset.  */
  if (!s390_decompose_shift_count (op, &base, &offset))
    return false;

  /* Don't allow any non-base hard registers.  Doing so without
     confusing reload and/or regrename would be tricky, and doesn't
     buy us much anyway.  */
  if (base && REGNO (base) < FIRST_PSEUDO_REGISTER && !ADDR_REG_P (base))
    return false;

  /* Unfortunately we have to reject constants that are invalid
     for an address, or else reload will get confused.  */
  if (!DISP_IN_RANGE (offset))
    return false;

  return true;
}

int
shift_count_or_setmem_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
    case PLUS:
    case CONST_INT:
      break;
    default:
      return false;
    }
  return 
(shift_count_or_setmem_operand_1 (op, mode));
}

static inline int
larl_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 108 "../../gcc/config/s390/predicates.md"
{
  /* Allow labels and local symbols.  */
  if (GET_CODE (op) == LABEL_REF)
    return true;
  if (GET_CODE (op) == SYMBOL_REF)
    return (!SYMBOL_REF_ALIGN1_P (op)
	    && SYMBOL_REF_TLS_MODEL (op) == 0
	    && (!flag_pic || SYMBOL_REF_LOCAL_P (op)));

  /* Everything else must have a CONST, so strip it.  */
  if (GET_CODE (op) != CONST)
    return false;
  op = XEXP (op, 0);

  /* Allow adding *even* in-range constants.  */
  if (GET_CODE (op) == PLUS)
    {
      if (GET_CODE (XEXP (op, 1)) != CONST_INT
          || (INTVAL (XEXP (op, 1)) & 1) != 0)
        return false;
      if (INTVAL (XEXP (op, 1)) >= (HOST_WIDE_INT)1 << 31
	  || INTVAL (XEXP (op, 1)) < -((HOST_WIDE_INT)1 << 31))
        return false;
      op = XEXP (op, 0);
    }

  /* Labels and local symbols allowed here as well.  */
  if (GET_CODE (op) == LABEL_REF)
    return true;
  if (GET_CODE (op) == SYMBOL_REF)
    return ((SYMBOL_REF_FLAGS (op) & SYMBOL_FLAG_ALIGN1) == 0
	    && SYMBOL_REF_TLS_MODEL (op) == 0
	    && (!flag_pic || SYMBOL_REF_LOCAL_P (op)));

  /* Now we must have a @GOTENT offset or @PLT stub
     or an @INDNTPOFF TLS offset.  */
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_GOTENT)
    return true;
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_PLT)
    return true;
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_INDNTPOFF)
    return true;

  return false;
}

int
larl_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LABEL_REF:
    case SYMBOL_REF:
    case CONST:
    case CONST_INT:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return 
(larl_operand_1 (op, mode));
}

static inline int
s390_comparison_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 166 "../../gcc/config/s390/predicates.md"
{
  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || XEXP (op, 1) != const0_rtx)
    return false;

  return (s390_branch_condition_mask (op) >= 0);
}

int
s390_comparison (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LT:
    case GT:
    case LE:
    case GE:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
    case UNEQ:
    case UNLT:
    case UNGT:
    case UNLE:
    case UNGE:
    case LTGT:
    case UNORDERED:
    case ORDERED:
      break;
    default:
      return false;
    }
  return (
(s390_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
cc_reg_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 178 "../../gcc/config/s390/predicates.md"
(REGNO (op) == CC_REGNUM))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_signed_integer_comparison_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 182 "../../gcc/config/s390/predicates.md"
{
  return (s390_compare_and_branch_condition_mask (op) >= 0);
}

int
s390_signed_integer_comparison (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LT:
    case GT:
    case LE:
    case GE:
      break;
    default:
      return false;
    }
  return (
(s390_signed_integer_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_unsigned_integer_comparison_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 188 "../../gcc/config/s390/predicates.md"
{
  return (s390_compare_and_branch_condition_mask (op) >= 0);
}

int
s390_unsigned_integer_comparison (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_unsigned_integer_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_alc_comparison_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 197 "../../gcc/config/s390/predicates.md"
{
  while (GET_CODE (op) == ZERO_EXTEND || GET_CODE (op) == SIGN_EXTEND)
    op = XEXP (op, 0);

  if (!COMPARISON_P (op))
    return false;

  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || XEXP (op, 1) != const0_rtx)
    return false;

  switch (GET_MODE (XEXP (op, 0)))
    {
    case CCL1mode:
      return GET_CODE (op) == LTU;

    case CCL2mode:
      return GET_CODE (op) == LEU;

    case CCL3mode:
      return GET_CODE (op) == GEU;

    case CCUmode:
      return GET_CODE (op) == GTU;

    case CCURmode:
      return GET_CODE (op) == LTU;

    case CCSmode:
      return GET_CODE (op) == UNGT;

    case CCSRmode:
      return GET_CODE (op) == UNLT;

    default:
      return false;
    }
}

int
s390_alc_comparison (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case ZERO_EXTEND:
    case SIGN_EXTEND:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_alc_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_slb_comparison_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 242 "../../gcc/config/s390/predicates.md"
{
  while (GET_CODE (op) == ZERO_EXTEND || GET_CODE (op) == SIGN_EXTEND)
    op = XEXP (op, 0);

  if (!COMPARISON_P (op))
    return false;

  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || XEXP (op, 1) != const0_rtx)
    return false;

  switch (GET_MODE (XEXP (op, 0)))
    {
    case CCL1mode:
      return GET_CODE (op) == GEU;

    case CCL2mode:
      return GET_CODE (op) == GTU;

    case CCL3mode:
      return GET_CODE (op) == LTU;

    case CCUmode:
      return GET_CODE (op) == LEU;

    case CCURmode:
      return GET_CODE (op) == GEU;

    case CCSmode:
      return GET_CODE (op) == LE;

    case CCSRmode:
      return GET_CODE (op) == GE;

    default:
      return false;
    }
}

int
s390_slb_comparison (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case ZERO_EXTEND:
    case SIGN_EXTEND:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_slb_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
load_multiple_operation_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 287 "../../gcc/config/s390/predicates.md"
{
  enum machine_mode elt_mode;
  int count = XVECLEN (op, 0);
  unsigned int dest_regno;
  rtx src_addr;
  int i, off;

  /* Perform a quick check so we don't blow up below.  */
  if (count <= 1
      || GET_CODE (XVECEXP (op, 0, 0)) != SET
      || GET_CODE (SET_DEST (XVECEXP (op, 0, 0))) != REG
      || GET_CODE (SET_SRC (XVECEXP (op, 0, 0))) != MEM)
    return false;

  dest_regno = REGNO (SET_DEST (XVECEXP (op, 0, 0)));
  src_addr = XEXP (SET_SRC (XVECEXP (op, 0, 0)), 0);
  elt_mode = GET_MODE (SET_DEST (XVECEXP (op, 0, 0)));

  /* Check, is base, or base + displacement.  */

  if (GET_CODE (src_addr) == REG)
    off = 0;
  else if (GET_CODE (src_addr) == PLUS
	   && GET_CODE (XEXP (src_addr, 0)) == REG
	   && GET_CODE (XEXP (src_addr, 1)) == CONST_INT)
    {
      off = INTVAL (XEXP (src_addr, 1));
      src_addr = XEXP (src_addr, 0);
    }
  else
    return false;

  for (i = 1; i < count; i++)
    {
      rtx elt = XVECEXP (op, 0, i);

      if (GET_CODE (elt) != SET
	  || GET_CODE (SET_DEST (elt)) != REG
	  || GET_MODE (SET_DEST (elt)) != elt_mode
	  || REGNO (SET_DEST (elt)) != dest_regno + i
	  || GET_CODE (SET_SRC (elt)) != MEM
	  || GET_MODE (SET_SRC (elt)) != elt_mode
	  || GET_CODE (XEXP (SET_SRC (elt), 0)) != PLUS
	  || ! rtx_equal_p (XEXP (XEXP (SET_SRC (elt), 0), 0), src_addr)
	  || GET_CODE (XEXP (XEXP (SET_SRC (elt), 0), 1)) != CONST_INT
	  || INTVAL (XEXP (XEXP (SET_SRC (elt), 0), 1))
	     != off + i * GET_MODE_SIZE (elt_mode))
	return false;
    }

  return true;
}

int
load_multiple_operation (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(load_multiple_operation_1 (op, mode)));
}

static inline int
store_multiple_operation_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 345 "../../gcc/config/s390/predicates.md"
{
  enum machine_mode elt_mode;
  int count = XVECLEN (op, 0);
  unsigned int src_regno;
  rtx dest_addr;
  int i, off;

  /* Perform a quick check so we don't blow up below.  */
  if (count <= 1
      || GET_CODE (XVECEXP (op, 0, 0)) != SET
      || GET_CODE (SET_DEST (XVECEXP (op, 0, 0))) != MEM
      || GET_CODE (SET_SRC (XVECEXP (op, 0, 0))) != REG)
    return false;

  src_regno = REGNO (SET_SRC (XVECEXP (op, 0, 0)));
  dest_addr = XEXP (SET_DEST (XVECEXP (op, 0, 0)), 0);
  elt_mode = GET_MODE (SET_SRC (XVECEXP (op, 0, 0)));

  /* Check, is base, or base + displacement.  */

  if (GET_CODE (dest_addr) == REG)
    off = 0;
  else if (GET_CODE (dest_addr) == PLUS
	   && GET_CODE (XEXP (dest_addr, 0)) == REG
	   && GET_CODE (XEXP (dest_addr, 1)) == CONST_INT)
    {
      off = INTVAL (XEXP (dest_addr, 1));
      dest_addr = XEXP (dest_addr, 0);
    }
  else
    return false;

  for (i = 1; i < count; i++)
    {
      rtx elt = XVECEXP (op, 0, i);

      if (GET_CODE (elt) != SET
	  || GET_CODE (SET_SRC (elt)) != REG
	  || GET_MODE (SET_SRC (elt)) != elt_mode
	  || REGNO (SET_SRC (elt)) != src_regno + i
	  || GET_CODE (SET_DEST (elt)) != MEM
	  || GET_MODE (SET_DEST (elt)) != elt_mode
	  || GET_CODE (XEXP (SET_DEST (elt), 0)) != PLUS
	  || ! rtx_equal_p (XEXP (XEXP (SET_DEST (elt), 0), 0), dest_addr)
	  || GET_CODE (XEXP (XEXP (SET_DEST (elt), 0), 1)) != CONST_INT
	  || INTVAL (XEXP (XEXP (SET_DEST (elt), 0), 1))
	     != off + i * GET_MODE_SIZE (elt_mode))
	return false;
    }
  return true;
}

int
store_multiple_operation (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(store_multiple_operation_1 (op, mode)));
}

enum constraint_num
lookup_constraint (const char *str)
{
  switch (str[0])
    {
    case 'A':
      if (!strncmp (str, "AR", 2))
        return CONSTRAINT_AR;
      if (!strncmp (str, "AS", 2))
        return CONSTRAINT_AS;
      if (!strncmp (str, "AT", 2))
        return CONSTRAINT_AT;
      if (!strncmp (str, "AQ", 2))
        return CONSTRAINT_AQ;
      break;
    case 'B':
      if (!strncmp (str, "BR", 2))
        return CONSTRAINT_BR;
      if (!strncmp (str, "BS", 2))
        return CONSTRAINT_BS;
      if (!strncmp (str, "BT", 2))
        return CONSTRAINT_BT;
      if (!strncmp (str, "BQ", 2))
        return CONSTRAINT_BQ;
      break;
    case 'C':
      return CONSTRAINT_C;
    case 'D':
      return CONSTRAINT_D;
    case 'G':
      return CONSTRAINT_G;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      if (!strncmp (str, "NxQD0", 5))
        return CONSTRAINT_NxQD0;
      if (!strncmp (str, "N3HD0", 5))
        return CONSTRAINT_N3HD0;
      if (!strncmp (str, "N2HD0", 5))
        return CONSTRAINT_N2HD0;
      if (!strncmp (str, "N1SD0", 5))
        return CONSTRAINT_N1SD0;
      if (!strncmp (str, "N1HS0", 5))
        return CONSTRAINT_N1HS0;
      if (!strncmp (str, "N1HD0", 5))
        return CONSTRAINT_N1HD0;
      if (!strncmp (str, "N0SD0", 5))
        return CONSTRAINT_N0SD0;
      if (!strncmp (str, "N0HS0", 5))
        return CONSTRAINT_N0HS0;
      if (!strncmp (str, "N0HD0", 5))
        return CONSTRAINT_N0HD0;
      if (!strncmp (str, "NxQDF", 5))
        return CONSTRAINT_NxQDF;
      if (!strncmp (str, "N1SDF", 5))
        return CONSTRAINT_N1SDF;
      if (!strncmp (str, "N0SDF", 5))
        return CONSTRAINT_N0SDF;
      if (!strncmp (str, "N3HDF", 5))
        return CONSTRAINT_N3HDF;
      if (!strncmp (str, "N2HDF", 5))
        return CONSTRAINT_N2HDF;
      if (!strncmp (str, "N1HDF", 5))
        return CONSTRAINT_N1HDF;
      if (!strncmp (str, "N0HDF", 5))
        return CONSTRAINT_N0HDF;
      if (!strncmp (str, "N0HSF", 5))
        return CONSTRAINT_N0HSF;
      if (!strncmp (str, "N1HSF", 5))
        return CONSTRAINT_N1HSF;
      if (!strncmp (str, "NxQSF", 5))
        return CONSTRAINT_NxQSF;
      if (!strncmp (str, "NxQHF", 5))
        return CONSTRAINT_NxQHF;
      if (!strncmp (str, "NxQH0", 5))
        return CONSTRAINT_NxQH0;
      if (!strncmp (str, "NxQS0", 5))
        return CONSTRAINT_NxQS0;
      break;
    case 'O':
      if (!strncmp (str, "Op", 2))
        return CONSTRAINT_Op;
      if (!strncmp (str, "On", 2))
        return CONSTRAINT_On;
      if (!strncmp (str, "Os", 2))
        return CONSTRAINT_Os;
      break;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      return CONSTRAINT_R;
    case 'S':
      return CONSTRAINT_S;
    case 'T':
      return CONSTRAINT_T;
    case 'U':
      return CONSTRAINT_U;
    case 'W':
      return CONSTRAINT_W;
    case 'Y':
      return CONSTRAINT_Y;
    case 'Z':
      if (!strncmp (str, "ZR", 2))
        return CONSTRAINT_ZR;
      if (!strncmp (str, "ZS", 2))
        return CONSTRAINT_ZS;
      if (!strncmp (str, "ZT", 2))
        return CONSTRAINT_ZT;
      if (!strncmp (str, "ZQ", 2))
        return CONSTRAINT_ZQ;
      break;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'c':
      return CONSTRAINT_c;
    case 'd':
      return CONSTRAINT_d;
    case 'e':
      return CONSTRAINT_e;
    case 'f':
      return CONSTRAINT_f;
    case 'm':
      return CONSTRAINT_m;
    case 't':
      return CONSTRAINT_t;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

enum reg_class
regclass_for_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_a: return ADDR_REGS;
    case CONSTRAINT_c: return CC_REGS;
    case CONSTRAINT_d: return GENERAL_REGS;
    case CONSTRAINT_f: return FP_REGS;
    case CONSTRAINT_t: return ACCESS_REGS;
    default: break;
    }
  return NO_REGS;
}

bool
constraint_satisfied_p (rtx op, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_C: return satisfies_constraint_C (op);
    case CONSTRAINT_D: return satisfies_constraint_D (op);
    case CONSTRAINT_G: return satisfies_constraint_G (op);
    case CONSTRAINT_I: return satisfies_constraint_I (op);
    case CONSTRAINT_J: return satisfies_constraint_J (op);
    case CONSTRAINT_K: return satisfies_constraint_K (op);
    case CONSTRAINT_L: return satisfies_constraint_L (op);
    case CONSTRAINT_M: return satisfies_constraint_M (op);
    case CONSTRAINT_P: return satisfies_constraint_P (op);
    case CONSTRAINT_Y: return satisfies_constraint_Y (op);
    case CONSTRAINT_NxQS0: return satisfies_constraint_NxQS0 (op);
    case CONSTRAINT_NxQD0: return satisfies_constraint_NxQD0 (op);
    case CONSTRAINT_N3HD0: return satisfies_constraint_N3HD0 (op);
    case CONSTRAINT_N2HD0: return satisfies_constraint_N2HD0 (op);
    case CONSTRAINT_N1SD0: return satisfies_constraint_N1SD0 (op);
    case CONSTRAINT_N1HS0: return satisfies_constraint_N1HS0 (op);
    case CONSTRAINT_N1HD0: return satisfies_constraint_N1HD0 (op);
    case CONSTRAINT_N0SD0: return satisfies_constraint_N0SD0 (op);
    case CONSTRAINT_N0HS0: return satisfies_constraint_N0HS0 (op);
    case CONSTRAINT_N0HD0: return satisfies_constraint_N0HD0 (op);
    case CONSTRAINT_NxQDF: return satisfies_constraint_NxQDF (op);
    case CONSTRAINT_N1SDF: return satisfies_constraint_N1SDF (op);
    case CONSTRAINT_N0SDF: return satisfies_constraint_N0SDF (op);
    case CONSTRAINT_N3HDF: return satisfies_constraint_N3HDF (op);
    case CONSTRAINT_N2HDF: return satisfies_constraint_N2HDF (op);
    case CONSTRAINT_N1HDF: return satisfies_constraint_N1HDF (op);
    case CONSTRAINT_N0HDF: return satisfies_constraint_N0HDF (op);
    case CONSTRAINT_N0HSF: return satisfies_constraint_N0HSF (op);
    case CONSTRAINT_N1HSF: return satisfies_constraint_N1HSF (op);
    case CONSTRAINT_NxQSF: return satisfies_constraint_NxQSF (op);
    case CONSTRAINT_NxQHF: return satisfies_constraint_NxQHF (op);
    case CONSTRAINT_NxQH0: return satisfies_constraint_NxQH0 (op);
    case CONSTRAINT_Os: return satisfies_constraint_Os (op);
    case CONSTRAINT_Op: return satisfies_constraint_Op (op);
    case CONSTRAINT_On: return satisfies_constraint_On (op);
    case CONSTRAINT_Q: return satisfies_constraint_Q (op);
    case CONSTRAINT_R: return satisfies_constraint_R (op);
    case CONSTRAINT_S: return satisfies_constraint_S (op);
    case CONSTRAINT_T: return satisfies_constraint_T (op);
    case CONSTRAINT_b: return satisfies_constraint_b (op);
    case CONSTRAINT_e: return satisfies_constraint_e (op);
    case CONSTRAINT_m: return satisfies_constraint_m (op);
    case CONSTRAINT_AQ: return satisfies_constraint_AQ (op);
    case CONSTRAINT_AR: return satisfies_constraint_AR (op);
    case CONSTRAINT_AS: return satisfies_constraint_AS (op);
    case CONSTRAINT_AT: return satisfies_constraint_AT (op);
    case CONSTRAINT_BQ: return satisfies_constraint_BQ (op);
    case CONSTRAINT_BR: return satisfies_constraint_BR (op);
    case CONSTRAINT_BS: return satisfies_constraint_BS (op);
    case CONSTRAINT_BT: return satisfies_constraint_BT (op);
    case CONSTRAINT_U: return satisfies_constraint_U (op);
    case CONSTRAINT_W: return satisfies_constraint_W (op);
    case CONSTRAINT_ZQ: return satisfies_constraint_ZQ (op);
    case CONSTRAINT_ZR: return satisfies_constraint_ZR (op);
    case CONSTRAINT_ZS: return satisfies_constraint_ZS (op);
    case CONSTRAINT_ZT: return satisfies_constraint_ZT (op);
    default: break;
    }
  return false;
}

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 137 "../../gcc/config/s390/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 255);

    case CONSTRAINT_J:
      return 
#line 143 "../../gcc/config/s390/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 4095);

    case CONSTRAINT_K:
      return 
#line 149 "../../gcc/config/s390/constraints.md"
(ival >= -32768 && ival <= 32767);

    case CONSTRAINT_L:
      return 
#line 157 "../../gcc/config/s390/constraints.md"
(TARGET_LONG_DISPLACEMENT ?
              (ival >= -524288 && ival <= 524287)
            : (ival >= 0 && ival <= 4095));

    case CONSTRAINT_M:
      return 
#line 165 "../../gcc/config/s390/constraints.md"
(ival == 2147483647);

    case CONSTRAINT_P:
      return 
#line 172 "../../gcc/config/s390/constraints.md"
(legitimate_reload_constant_p (GEN_INT (ival)));

    case CONSTRAINT_NxQS0:
      return 
#line 205 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQS0", ival));

    case CONSTRAINT_NxQD0:
      return 
#line 211 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQD0", ival));

    case CONSTRAINT_N3HD0:
      return 
#line 217 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("3HD0", ival));

    case CONSTRAINT_N2HD0:
      return 
#line 223 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("2HD0", ival));

    case CONSTRAINT_N1SD0:
      return 
#line 229 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1SD0", ival));

    case CONSTRAINT_N1HS0:
      return 
#line 235 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HS0", ival));

    case CONSTRAINT_N1HD0:
      return 
#line 241 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HD0", ival));

    case CONSTRAINT_N0SD0:
      return 
#line 247 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0SD0", ival));

    case CONSTRAINT_N0HS0:
      return 
#line 253 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HS0", ival));

    case CONSTRAINT_N0HD0:
      return 
#line 259 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HD0", ival));

    case CONSTRAINT_NxQDF:
      return 
#line 265 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQDF", ival));

    case CONSTRAINT_N1SDF:
      return 
#line 271 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1SDF", ival));

    case CONSTRAINT_N0SDF:
      return 
#line 277 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0SDF", ival));

    case CONSTRAINT_N3HDF:
      return 
#line 283 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("3HDF", ival));

    case CONSTRAINT_N2HDF:
      return 
#line 289 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("2HDF", ival));

    case CONSTRAINT_N1HDF:
      return 
#line 295 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HDF", ival));

    case CONSTRAINT_N0HDF:
      return 
#line 301 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HDF", ival));

    case CONSTRAINT_N0HSF:
      return 
#line 307 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HSF", ival));

    case CONSTRAINT_N1HSF:
      return 
#line 313 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HSF", ival));

    case CONSTRAINT_NxQSF:
      return 
#line 319 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQSF", ival));

    case CONSTRAINT_NxQHF:
      return 
#line 325 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQHF", ival));

    case CONSTRAINT_NxQH0:
      return 
#line 331 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQH0", ival));

    case CONSTRAINT_Os:
      return 
#line 347 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('s', ival));

    case CONSTRAINT_Op:
      return 
#line 356 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('p', ival));

    case CONSTRAINT_On:
      return 
#line 365 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('n', ival));

    default: break;
    }
  return false;
}

bool
insn_extra_memory_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_Q:
      return true;

    case CONSTRAINT_R:
      return true;

    case CONSTRAINT_S:
      return true;

    case CONSTRAINT_T:
      return true;

    case CONSTRAINT_b:
      return true;

    case CONSTRAINT_e:
      return true;

    case CONSTRAINT_m:
      return true;

    case CONSTRAINT_AQ:
      return true;

    case CONSTRAINT_AR:
      return true;

    case CONSTRAINT_AS:
      return true;

    case CONSTRAINT_AT:
      return true;

    default: break;
    }
  return false;
}

bool
insn_extra_address_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_Y:
      return true;

    case CONSTRAINT_U:
      return true;

    case CONSTRAINT_W:
      return true;

    case CONSTRAINT_ZQ:
      return true;

    case CONSTRAINT_ZR:
      return true;

    case CONSTRAINT_ZS:
      return true;

    case CONSTRAINT_ZT:
      return true;

    default: break;
    }
  return false;
}

